/**************************************
  Basic Disk Operating System
  CP/M v2.2 port for eZ80F92
  disk is simulated on FAT16/32 SD/MMC card
  (C) 2007 Hynek Sladky; sladky@mujmail.cz
 *************************************/
#ifndef _BDOS_h_
#define	_BDOS_h_

#include <stdio.h>

#define	DISK_CNT	4

enum {
  system_reset, console_input, console_output, reader_input, 
  punch_output, list_output, console_direct, getIObyte,
  setIObyte, print_string, read_console_buffer, get_console_status,
  version_number, reset_disk_system, select_disk, open_file,
  close_file, search_first, search_next, delete_file,
  read_file, write_file, make_file, rename_file,
  login_vector, current_disk, setDMA, get_alloc_vector,
  write_protect_disk, getROvect, file_set_attr, get_diskpar,
  get_set_user, file_read_random, file_write_random, file_size,
  set_random_record, reset_drive, dummy_x26, dummy_x27,
  file_write_random_zero
};
/**
typedef struct {
  unsigned char maxlen;
  unsigned char datalen;
  unsigned char data[1];
} func10_buffer;
**/

/**
  pozicovani v souboru (pocitadlo ve FCB):
  modnum <0..15> : extent <0..31> : currec <0..127>
  toto pocitani NEODPOVIDA pocitani jednotlivych polozek adresare!!!
**/
typedef struct {
  unsigned char drive; // FCB: drive <0..16>; DIR: user <0..15>
  char name[8];
  char ext[3];
  unsigned char extent; // FCB: position counter (mid) <0..31>; DIR: dir entry extension number <0..255>; MyZ80 cisluje od 1 ...
  unsigned char ubytes; // FCB: system1; DIR: nepouzito (vzdy 0)
  unsigned char modnum; // FCB: position counter (hi) <0..15>; bit 7: file write bit (0 indicates write); DIR: vzdy 0
  unsigned char reccount; // FCB: sector count <0..128> in this 'FCB extent'; DIR: sector count for last allocation block in this extent <0..128> depends on allocation block size
  // 16B system info
  FILE *f;
  unsigned char dummy[12];
  unsigned char currec; // FCB: position counter (lo) <0..127>, points to sector to be read/written
  unsigned short recreq; // request for random positioned sector (3 bytes!!!)
} __attribute__ ((packed)) FCB_type;

extern unsigned char curpos;

void StartNewLine (unsigned char pos);

unsigned short BDOS (unsigned char func, unsigned short par);
//void BDOS_init (void);

void illegal (char *info);

#endif

