/**************************************
  Basic Input Output System
  CP/M v2.2 port for eZ80F92
  disk is simulated on FAT16/32 SD/MMC card
  (C) 2007 Hynek Sladky; sladky@mujmail.cz
 *************************************/
#ifndef _BIOS_h_
#define	_BIOS_h_

#include <setjmp.h>
#include <stdio.h>

typedef struct {
  unsigned short sectors;
  unsigned char blk_shift;
  unsigned char blk_mask;
  unsigned char ex_mask;
  unsigned short maxblk;
  unsigned short dircnt;
  unsigned char al0, al1;
  unsigned short chksize;
  unsigned short res_trk;
} __attribute__ ((packed)) DPB_type;

// variables
extern unsigned short DMA;
extern jmp_buf WBOOT_jmp;
extern jmp_buf BOOT_jmp;

//#define	BOOT	main
// general functions
void BOOT (void);
void WBOOT (void);
// console functions
unsigned char CONSTAT (void);
unsigned char CONIN (void);
void CONOUT (unsigned char c);
//#define	CONSTAT	kbhit
#define	CONSTAT dkbhit
#define	CONIN	dgetc
#define	CONOUT	dputc
unsigned char dkbhit (void);
unsigned char dgetc (void);
void dputc (unsigned char);
//#define	dgetc	getchar
//#define	dputc	putchar
//#define	dprintf	printf
#define	dprintf(args...) fprintf (stderr, args)
#define	dputs	puts
// additional devices' functions
unsigned char LISTST (void);
void LIST (unsigned char c);
void PUNCH (unsigned char c);
unsigned char READER (void);
// disk functions
void HOME (void);
unsigned short SELDSK (unsigned char disk);
void SETTRK (unsigned short track);
void SETSEC (unsigned short sector);
void SETDMA (unsigned short addr);
unsigned char READ (void);
unsigned char WRITE (void);
unsigned short SECTRN (unsigned short sector, unsigned short table);

#endif

