/**************************************
  Basic Disk Operating System
  CP/M v2.2 port for eZ80F92
  disk is simulated on FAT16/32 SD/MMC card
  (C) 2007 Hynek Sladky; sladky@mujmail.cz
 *************************************/
#ifndef _CPM_RAM_h_
#define	_CPM_RAM_h_

#include "BIOS.h"
#include "BDOS.h"
#include <stdio.h>

// cela CPM pamet
extern unsigned char CPM_RAM[65536];
// promenne
//extern unsigned char ioByte;
//extern unsigned char curDisk;
//extern FCB_type defaultFCB;
//extern FCB_type defaultFCB2;
//extern unsigned char defaultBUF[128];
#define	ioByte	CPM_RAM[3]
#define	curDisk	CPM_RAM[4]

#define	defaultFCB_offs	0x005C
#define	defaultBUF_offs	0x0080
#define	TPA_offs	0x0100
//#define	TPA_top_offs	0xEC00
#define	TPA_top_offs	0xEC00
#define	SP_offs		0xEFF0
#define	bdos_vec 	0xF000L
#define	wboot_vec	0xF803L

#define	defaultFCB	(*(FCB_type*)(CPM_RAM+defaultFCB_offs))
#define	defaultFCB2	(*(FCB_type*)(CPM_RAM+0x6C))
#define	defaultBUF	(CPM_RAM+defaultBUF_offs)
// misto pro spousteni programu
//extern unsigned char TPA_start[];
//extern unsigned char TPA_top[];
#define	TPA_start	(CPM_RAM+TPA_offs)
#define	TPA_top		(CPM_RAM+TPA_top_offs)
// buffer pro prikazovou radku CCP
//extern unsigned char CCPbuf[129];
#define	CCPbuf_offs	0xFC00
#define	CCPbuf		(CPM_RAM+CCPbuf_offs)
// BIOS DPB area
//extern unsigned short diskParHeader[8];
//extern DPB_type DPB;
//extern unsigned char ALV[32];
//extern unsigned char dirbuf[128];

#define	diskParHeader_offs	0xF880
#define	DPB_offs		0xF890
#define	ALV_offs		0xF8A0
#define	CSV_offs		0xF8C0
#define	dirbuf_offs		0xF8E0

#define	diskParHeader	(unsigned short*)(CPM_RAM+diskParHeader_offs)
#define	DPB		(*(DPB_type*)(CPM_RAM+DPB_offs))
#define	ALV		(CPM_RAM+ALV_offs)
#define	dirbuf		(CPM_RAM+dirbuf_offs)

// adresy pro trapovani systemovych funkci
#define	bdos_trap	0xFFFE
#define	boot_trap	0xFFFC

// pamet nepristupna ze Z80 rezimu: 
// buffery pro FAT
//extern unsigned char file_buf[MAX_FILES+1][512];
// pamet pro volne pouziti...
//extern unsigned char free_RAM[];

// funkce
//extern unsigned char bdos_vec[3];
//extern unsigned char wboot_vec[1];
//extern unsigned char bdos_code[1];

#endif

