#include <stdio.h>
#include <windows.h>

#include "args.h"

#include "z80\z80.h"
#include "BIOS.h"
#include "BDOS.h"
#include "CCP.h"

/**
Chyby:
======
- pokud se ceka v BDOSu/BIOSu, tak se nevyhodnoti BREAK_request!
  viz napr. prvni cekani v rogue
- v simulatoru se asi nepouziva korektne modnum, resp. bit 7 (pripadne bit 6?)
  v BDOSu se kontroluje, zda je bit7 nulovy -> zapis cehosi (upravene delky do adresare?)

ToDo:
=====
o moznost spustit prikazovy soubor (urcite z prikazove radky win32, ale take z radky CP/M)
  o implementace ARGS
- pro ruzne programy bez manualu (nebo bez jejich cteni:-) doplnit nouzovy restart simulatoru
  skoro bych nejradsi dal CTRL+BREAK i kdyz tim prijdu o systemovou funkci ukonceni (zustane stale moznost zavrit mysi)
  - ^C i ^Break stale nejak zustava nekde aktivni, protoze BAT po ukonceni simulatoru se pta, zda ma skoncit nebo pokracovat...

- podpora pro SUBMIT - nejakym zpusobem se zkracuje otevreny soubor...
  na PC se to IMHO dela SEEKem a nasledne zapisem nuloveho poctu znaku
    Write zero bytes to file (Int 21h func 40h)
  cpp to provadi nasledovne:
  - vynuluje FCB.modnum
  - dekrementuje FCB.reccount
  - zavre soubor: v okamziku zavreni se (asi) ulozi do adresare aktualni FCB...
  originalni BDOS pred uzavrenim kontroluje bit 7 v .modnum: pokud je jedna, tak nic nedela
    pokud je nula, tak to dela jakesi operace - hleda polozku souboru v adresari ...
    to znamena, ze pri otevreni je potreba nastavit nejvyssi bit...
    nekde mam kontrolu, zda modnum>15 bez maskovani...

- mozna budu potrebovat manual k Microsoft basicu pro CP/M
  save "ahoj.bas",a
- ambiguous drive code? viz search first/next

Navod:
======
- ^Q se preklada na ^C
- levy+pravy CTRL zpusobi ukonceni aplikace (BREAK_request)

**/

// ====================================
// rizeni prekladu
// ------------------------------------
#define	CON_ANSI	// ANSI funkce pro vystup na konzoli
// ====================================
// promenne pro zpracovani prikazove radky
// ------------------------------------
int help = 0;
char *ae_name = NULL;
char *auto_name = "autoexec.cpm";
ARGS args[] = {
  {ARGS_OPTINTEGER, "-?", 0, &help, 1, ""},
  {ARGS_OPTINTEGER, "--help", 0, &help, 1, "print this help"},
  {ARGS_STRING, "-a", 0, &auto_name, 0, ""},
  {ARGS_STRING, "--autoexec", "FILE", &auto_name, 0, "set autoexec file"},
  {ARGS_SWITCH, "-", 0, &help, 1, NULL},
  {0}
};
// ====================================
// globalni promenne pro konzoli
// ------------------------------------
HANDLE hConIn, hConOut;
// ====================================
// konzolove funkce
// ====================================
// test znaku na vstupu
// ------------------------------------
int BREAK_request;
unsigned char dkbhit (void) {
INPUT_RECORD ir;
DWORD size;
  // dotaz na stav bufferu win32 konzole
  PeekConsoleInput (hConIn, &ir, 1, &size);
  // pokud to neni KEY_EVENT nebo keyDown, tak to odstranim a vratim 0
  if (size && (ir.EventType!=KEY_EVENT || !ir.Event.KeyEvent.bKeyDown || !ir.Event.KeyEvent.uChar.AsciiChar)) {
    ReadConsoleInput (hConIn, &ir, 1, &size);
    size=0;
  }
  if (ir.EventType == KEY_EVENT && (ir.Event.KeyEvent.dwControlKeyState & (LEFT_CTRL_PRESSED | RIGHT_CTRL_PRESSED)) == (LEFT_CTRL_PRESSED | RIGHT_CTRL_PRESSED))
    BREAK_request=1;
  return (size)?0xFF:0x00;
}
// ------------------------------------
// precteni znaku ze vstupu
// ------------------------------------
unsigned char dgetc (void) {
INPUT_RECORD ir;
DWORD size;
  // dotaz na stav bufferu win32 konzole
  do {
    PeekConsoleInput (hConIn, &ir, 1, &size);
    if (size) {
      ReadConsoleInput (hConIn, &ir, 1, &size);
      if (ir.EventType==KEY_EVENT && ir.Event.KeyEvent.bKeyDown && ir.Event.KeyEvent.uChar.AsciiChar) {
	//dprintf ("key: %02X\n", ir.Event.KeyEvent.uChar.AsciiChar);
	// protoze ^C je ve win32 pro ukonceni programu, pouziju ^Q -> ^C
	if (ir.Event.KeyEvent.uChar.AsciiChar == 0x11)
	  ir.Event.KeyEvent.uChar.AsciiChar = 0x03;
	//if (ir.Event.KeyEvent.uChar.AsciiChar=='\x1B') return 0x03; // ^C
	return ir.Event.KeyEvent.uChar.AsciiChar;
      }
    } else {
      Sleep (10);
    }
  } while (1);
  return 0;
}
// ------------------------------------
// ???
// ------------------------------------
int getnum (char *buf, int *val);
// ------------------------------------
// vystup znaku
// ------------------------------------
#ifdef CON_ANSI
// ------------------------------------
// vystup znaku s podporou ANSI
// ------------------------------------
void dputc (unsigned char c) {
static char esc[32];
static int escl = 0;
static int last_char, last_line;
int x,y;
CONSOLE_SCREEN_BUFFER_INFO bfin;
DWORD cnt;

  if (c=='\x1B') {
    escl=0;
    esc[escl++]=c;
  } else
  if (escl) {
    esc[escl++]=c;
    if ((c>='A' && c<='Z') || (c>='a' && c<='z')) {
      // vykonani ESC prikazu
      if (esc[1]=='[') {
	switch (c) {
	case 'H':
	  // cursor positioning
	  escl = 2;
	  x = y = 0;
	  escl += getnum (&esc[escl], &y);
	  if (esc[escl]==';') escl++;
	  escl += getnum (&esc[escl], &x);
	  if (x) x--;
	  if (y) y--;
	  GetConsoleScreenBufferInfo (hConOut, &bfin);
	  bfin.dwCursorPosition.X = x;
	  bfin.dwCursorPosition.Y = bfin.srWindow.Top+y;
	  SetConsoleCursorPosition (hConOut, bfin.dwCursorPosition);
	  break;
	case 'J':
	  // erasing screen
	  GetConsoleScreenBufferInfo (hConOut, &bfin);
	  switch (esc[2]) {
	    case 'J':
	    case '0': // from cursor to end of screen
	      FillConsoleOutputCharacter (hConOut, 0, 80*25-bfin.dwCursorPosition.X-80*bfin.dwCursorPosition.Y, bfin.dwCursorPosition, &cnt);
	      break;
	    case '1': // from beginning of screen to cursor
	      x = bfin.dwCursorPosition.X + 80*bfin.dwCursorPosition.Y;
	      bfin.dwCursorPosition.X = 0;
	      bfin.dwCursorPosition.Y = bfin.srWindow.Top;
	      FillConsoleOutputCharacter (hConOut, 0, x, bfin.dwCursorPosition, &cnt);
	      break;
	    case '2': // entire screen
	      bfin.dwCursorPosition.X = 0;
	      bfin.dwCursorPosition.Y = bfin.srWindow.Top;
	      SetConsoleCursorPosition (hConOut, bfin.dwCursorPosition);
	      FillConsoleOutputCharacter (hConOut, 0, 80*25, bfin.dwCursorPosition, &cnt);
	      break;
	    default:
	      break;
	  }
	  break;
	case 'K':
	  // erasing line
	  GetConsoleScreenBufferInfo (hConOut, &bfin);
	  switch (esc[2]) {
	    case 'K':
	    case '0': // from cursor to end of line
	      FillConsoleOutputCharacter (hConOut, 0, 80-bfin.dwCursorPosition.X, bfin.dwCursorPosition, &cnt);
	      break;
	    case '1': // from beginning to cursor
	      x=bfin.dwCursorPosition.X;
	      bfin.dwCursorPosition.X=0;
	      FillConsoleOutputCharacter (hConOut, 0, x, bfin.dwCursorPosition, &cnt);
	      break;
	    case '2': // entire line
	      bfin.dwCursorPosition.X=0;
	      FillConsoleOutputCharacter (hConOut, 0, 80, bfin.dwCursorPosition, &cnt);
	      break;
	    default:
	      break;
	  }
	  break;
	case 'm':
	  // character attributes...
	  // unsupported but w/o reporting them
	  break;
	default:
	  esc[escl]=0;
	  fprintf (stderr, "\nUnsupported ESC sequence \"%s\"!\n", &esc[1]);
	  break;
	}
      } else {
	esc[escl]=0;
	fprintf (stderr, "\nUnsupported ESC sequence \"%s\"!\n", &esc[1]);
      }
      escl=0;
    }
  } else {
    GetConsoleScreenBufferInfo (hConOut, &bfin);
    if (last_char && (c=='\r' || c=='\n')) {
      bfin.dwCursorPosition.Y--;
      SetConsoleCursorPosition (hConOut, bfin.dwCursorPosition);
    }
    putchar (c);
    last_char=(bfin.dwCursorPosition.X==79 && c>=' ');
    last_line=(bfin.dwCursorPosition.Y==24 && c>=' ');
/**
    // pri rucnim tisku se museji zpracovavat znaky \r\n
    GetConsoleScreenBufferInfo (hConOut, &bfin);
    FillConsoleOutputCharacter (hConOut, c, 1, bfin.dwCursorPosition, &cnt);
    bfin.dwCursorPosition.X++;
    if (bfin.dwCursorPosition.X>=80) {
      bfin.dwCursorPosition.X=0;
      bfin.dwCursorPosition.Y++;
    }
    SetConsoleCursorPosition (hConOut, bfin.dwCursorPosition);
**/
  }
}
#else
// ------------------------------------
// obycejny vystup znaku (bez ANSI)
// ------------------------------------
void dputc (unsigned char c) {putchar (c);}
#endif
// ------------------------------------
// struktura pro Z80 simulator
// ------------------------------------
Z80state_type Z80state;
jmp_buf BOOT_jmp;
unsigned char CPM_RAM[65536];
char sys_path[1024];
// ====================================
// hlavni funkce programu
// ------------------------------------
int main (int argc, char *argv[]) {

  if (args_parse_args (argc, argv, args, ":=#") || help) {
    printf ("This is CP/M 2.2 simulator v0.1 (C) 2007-2008 Hynek Sladky\n");
    printf ("Usage: %s [options]\n", argv[0]);
    args_print_help (args);
    return 0;
  }
  
  GetCurrentDirectory (1024, sys_path);
  setjmp (BOOT_jmp);
  ae_name = auto_name;
  fprintf (stderr, "This is CP/M 2.2 simulator v0.1 (C) JUL 2007 Hynek Sladky\n");

  // get Console In/Out handles
  hConIn = GetStdHandle (STD_INPUT_HANDLE);
  hConOut = GetStdHandle (STD_OUTPUT_HANDLE);
  
/**
  {
  DWORD dw;
  char buf[26*80];
  COORD cp;
    for (dw=0; dw<25*80; dw++)
      buf[dw]='A';
    buf[dw]=0;
    cp.X = cp.Y = 0;
    SetConsoleCursorPosition (hConOut, cp);
    WriteConsole (hConOut, buf, 80*25, &dw, NULL);
    cp.Y=2;
    SetConsoleCursorPosition (hConOut, cp);
    printf ("Done.");
    while (1);
  }
**/
  //volani BIOS
  BOOT ();

  return 0;
}
