/* Miscellaneous definitions for xz80, copyright (C) 1994 Ian Collier.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifdef Z80_INTERNALS

#define fetch(x) (memram[x])
#define fetch2(x) ((fetch((x)+1)<<8)|fetch(x))

#define store(x,y) memram[x]=y

#define store2b(x,h,l) do { memram[x]=l; memram[x+1]=h; } while(0)

#define store2(x,y) store2b(x,(y)>>8,(y)&255)

#if 0
#ifdef __GNUC__
static void inline storefunc(unsigned short ad,unsigned char b){
   store(ad,b);
}
#undef store
#define store(x,y) storefunc(x,y)

static void inline store2func(unsigned short ad,unsigned char b1,unsigned char b2){
   store2b(ad,b1,b2);
}
#undef store2b
#define store2b(x,hi,lo) store2func(x,hi,lo)
#endif
#endif

#define bc ((b<<8)|c)
#define de ((d<<8)|e)
#define hl ((h<<8)|l)

#else

#include "PalmOS\PceNativeCall.h"

#endif

// global/public definitions
typedef struct shared_t {
  unsigned long ram; // ukazatel na RAM
  // citac instrukcnich cyklu a maximalni hodnota citace instrukcnich cyklu pro navrat do hlavniho programu
  unsigned long tstates, event_next_event;
  // registry Z80
  unsigned char a, f, b, c, d, e, h, l;
  unsigned char r, a1, f1, b1, c1, d1, e1, h1, l1, i, iff1, iff2, im, xx1, xx2, xx3;
  unsigned short pc;
  unsigned short ix, iy, sp;
} Z80state_type;

extern Z80state_type Z80state;
// hlavicka funkce pro Z80 simulator
void Z80sim (const void *emulStateP, unsigned char *userData68KP, Call68KFuncType *call68KFuncP);
